#ifndef PANEL_PERFORMANCE_H
#define PANEL_PERFORMANCE_H

#ifndef PANEL_H
#include "Panel.h"
#endif

#ifndef DYNAMIC_SINGLETON_H
#include "Dynamic_singleton.h"
#endif

#ifndef UI_PANEL_PERFORMANCE_H
#include "ui_Panel_performance.h"
#endif

#ifndef MODEL_SINGLETON_VIEW_H
#include "Model_singleton_view.h"
#endif

#include <QTimer>

namespace MM
{

class Panel_performance
:
    public Panel,
    public Ui_Panel_performance,
    public Model_singleton_view,
    public Dynamic_singleton <Panel_performance>
{
    Q_OBJECT
    QTimer qtimer_;

public:    
    Panel_performance ();
   ~Panel_performance ();
    
    void                renew_current_model (Model &) {renew_values();}
    void                renew (Model_event::Hint) {}

public slots:
    void    renew_values();
    void    use_atom_pair_lists(int state);

    void    set_list_1(int);
    void    set_list_2(int);
    void    set_list_3(int);

    void    set_Skin   (double);
    void    set_Skin_2 (double);
    void    set_Skin_3 (double);

    void    set_Switch (double);

    void    cut_large_forces (int state);
};

}//MM

#endif //PANEL_PERFORMANCE_H
